(defun CNT-LINES (HFN / NH) ;HoldFileName
 (setq NH (open HFN "r") CNT 0)
 (while (read-line NH)(setq CNT (1+ CNT))) 
 (close NH)) 

(defun DO-COM (PN EXT CN COM / CNT LEN DOSEXT FILE-TOO HDG) ;PathName, EXTension,CatalogName,COMmand
 (repeat 25(print))(textscr) 
 (princ (strcat "\nPlease wait...building catalog " EXT)) 
 (print) 
 (setq LEN 1 CNT 0 HDG (strcat (chr 32) EXT (chr 32)) 
       DOSEXT (strcat (chr 32) (substr EXT 3 3) (chr 32)) 
       FILE-TOO "")
 (WRITE-DIR (strcat PN EXT) CN DOSEXT) 
 (setq PEEK (open CN "r"))
 (if (/= (read-line PEEK) nil) 
  (progn
   (apply '(lambda (TXT-LOC) (repeat 50 
                               (grtext TXT-LOC "        ") 
                               (setq TXT-LOC (1+ TXT-LOC)))) '(0)) 
   (POP-SCRN HDG "********" CN 2 "mc") 
   (if (/= CANCEL? "YES") 
    (progn
     (repeat 8 
       (if (/= (substr HLDFILE LEN 1) (chr 32)) 
        (setq FILE-TOO (strcat FILE-TOO (substr HLDFILE LEN 1)) 
              LEN (1+ LEN)))) 
     (if (= COM "LOAD") 
      (setq LOADFLAG "YES" RUNFILE (strcat PN FILE-TOO ".LSP"))
      (command COM (strcat PN FILE-TOO (substr EXT 2)))
     )))) 
  (progn
   (graphscr)(print) 
   (princ "\n\t\t< Illegal path or no Matching Files >") 
   (print) 
   (getstring "\npress any key to continue..."))))
 
(defun PICK-FILE (/ PT1) 
 (repeat 5 (print)) 
 (prompt "\nSelect File : ") 
 (setq PT1 (grread) SEL-LOC (car PT1) FILE-SEL (cadr PT1))
 (cond
  ((/= SEL-LOC 4) (PICK-FILE)) 
  ((and (= CUR-PG NUM-PGS)(= FILE-SEL 19)) 
   (setq MORE? "NO" CANCEL? "YES")) 
  ((and (= CUR-PG NUM-PGS) 
    (or (> FILE-SEL (1+ CH-LST)) (= FILE-SEL 0) (= FILE-SEL 1))) 
   (PICK-FILE)) 
  ((or (= FILE-SEL 0) (= FILE-SEL 1) (> FILE-SEL 19)) (PICK-FILE)) 
  ((and (= SEL-LOC 4)(= FILE-SEL 19))(setq MORE? "YES")) 
  ((and (= SEL-LOC 4)(/= FILE-SEL 19))(setq MORE? "NO")))) 

(defun POP-SCRN (HDG L2 FN SN NH / CTR CNT TXT-LOC SN NH) ; HeaDinG, Line2, FileName, StartNumber, NameHolder
 (setq CNT 0 TXT-LOC 0)
 (CNT-LINES FN) 
 (repeat 19(grtext TXT-LOC "        ")(setq TXT-LOC (1+ TXT-LOC))) 
 (if (> CNT 17) 
  (progn
   (grtext TXT-LOC "* Next *") 
   (setq TXT-LOC (1+ TXT-LOC)))) 
 (repeat 10 
   (grtext TXT-LOC "        ") 
   (setq TXT-LOC (1+ TXT-LOC))) 
 (grtext 0 HDG) 
 (grtext 1 L2) 
 (setq NH (open FN "r") CH-LST 0 CTR SN 
       NUM-PGS (fix (+ 1 (/ CNT 17.00))) 
       TXT-LOC SN OLD-PGS 0 CUR-PG 1 
       CH-REM (1- CNT) CUR-MEM 1 
       MORE? "yes" CANCEL? "NO" HLDFILE nil)
 (if (> CH-REM 17) 
  (setq CH-PG 17)
  (setq CH-LST CH-PG 
        CH-PG CH-REM)) 
 (while (/= MORE? "NO") 
   (print HLDFILE) 
   (if (= CUR-PG NUM-PGS) 
    (progn
     (setq CH-LST CH-REM TXT-LOC SN)
     (repeat 17 
       (grtext TXT-LOC "        ") 
       (setq TXT-LOC (1+ TXT-LOC))) 
     (grtext TXT-LOC " Return "))) 
   (setq TXT-LOC SN)
   (repeat CH-PG 
     (grtext TXT-LOC (read-line NH)) 
     (setq TXT-LOC (1+ TXT-LOC) 
           CH-REM (1- CH-REM) 
           CUR-MEM (1+ CUR-MEM))
    (if (> CH-REM 17)(setq CH-PG 17)(setq CH-PG CH-REM))) 
   (PICK-FILE) 
   (setq OLD-PGS (1+ OLD-PGS) CUR-PG (1+ CUR-PG))) 
 (close NH) 
 (if (/= CANCEL? "YES") 
  (progn
   (setq NH (open FN "r"))
   (repeat (+ (* 17 (* (1- OLD-PGS))) (- FILE-SEL 2)) 
    (print (read-line NH))) 
   (setq HLDFILE (read-line NH))
   (close NH) 
   (print HLDFILE))))
 
(defun SEL-OPT (IG PS DF OL / HOLD)  ;InitGet, PromptString,DeFault, OptionLine
 (initget IG) 
 (repeat 24 (print)) 
 (princ PS)(print)(princ "\n") 
 (setq OPTION DF HOLD OPTION 
       OPTION (getkword (strcat OL OPTION ">: ")))
 (if (null OPTION)(setq OPTION HOLD)) 
 (repeat 5 (print)) 
 (prin1))
 
(defun WRITE-DIR (PN CAT-FILE EXT / NH CUR-LINE CNT) ;Path Name, CATalogFile, Extension 
 (command "DIR" (strcat PN ">HOLD.DIR")) 
 (CNT-LINES "HOLD.DIR") 
 (setq NH (open "HOLD.DIR" "r") CAT-FILE (open CAT-FILE "w"))
 (repeat (1- CNT) 
   (setq CUR-LINE (read-line NH))
   (if (= (substr CUR-LINE 9 5) (strcase EXT)) 
    (write-line (substr CUR-LINE 1 12) CAT-FILE))) 
 (close NH)(close CAT-FILE)(prin1))

(defun C:USEDOS () 
 (graphscr)(repeat 5 (print)) 
 (setq LOADFLAG "NO" DEF-PATH (getvar "DWGPREFIX") 
       PATHNAME (getstring (strcat "\nPath to search <" DEF-PATH "> : ")))
 (if (= PATHNAME "")(setq PATHNAME DEF-PATH)) 
 (if (/= (substr PATHNAME (strlen PATHNAME)) "\\") 
  (setq PATHNAME (strcat PATHNAME "\\"))) 
 (SEL-OPT "Block Lisp Slide X" "\nSelect file TYPE... " "Lisp" "Block/Lisp/Slide/eXit<") 
 (cond
  ((= OPTION "Block") (DO-COM PATHNAME "*.dwg" "BLOCKS.CAT" "INSERT")) 
  ((= OPTION "Lisp") 
    (SEL-OPT "Browse Edit Load" "\nSelect TASK... " "Load" "Browse/Edit/Load<")
    (cond
     ((= OPTION "Browse") (DO-COM PATHNAME "*.lsp" "LISP.CAT" "TYPE")) 
     ((= OPTION "Edit") (DO-COM PATHNAME "*.lsp" "LISP.CAT" "Edit")) 
     ((= OPTION "Load") (DO-COM PATHNAME "*.lsp" "LISP.CAT" "LOAD"))))
  ((= OPTION "Slide") (DO-COM PATHNAME "*.sld" "SLIDE.CAT" "VSLIDE")) ) 
 (grtext)(repeat 5 (print)) 
 (if (= LOADFLAG "YES") 
  (progn
   (princ (strcat "\nLoading <" RUNFILE ">\n")) 
   (load RUNFILE)) 
  (prin1)))

